<?php declare(strict_types=1);

namespace Everyware\Exceptions;

use GuzzleHttp\Exception\ConnectException;
use GuzzleHttp\Psr7\Request;

class PersistentOcConnectionException extends OcConnectionException
{
    public function __construct(string $method, string $uri)
    {
        parent::__construct(new ConnectException(
            'Encountered connection issues with Open Content. Stale mode entered.',
            new Request(strtoupper($method), $uri)
        ));
    }
}
