<?php declare(strict_types=1);

namespace Everyware\Helpers;

use Everyware\Contracts\OcResponseCacheValidator;
use Everyware\Exceptions\InvalidOcResponseException;

class ContentTypesResponseValidator implements OcResponseCacheValidator
{
    /**
     * @inheritDoc
     */
    public function validateResponse(string $response): void
    {
        $responseJson = json_decode($response, true) ?? [];

        if (empty($responseJson)) {
            throw new InvalidOcResponseException('The response is empty');
        }

        $contentTypes = $responseJson['contentTypes'] ?? [];

        if (empty($contentTypes)) {
            throw new InvalidOcResponseException('The response does not contain any content types');
        }
    }
}
