<?php

class OcObjectsWidget extends OcWidgetBase
{
    public function oc_widget_name()
    {
        return 'OC Objects Display';
    }

    /*
     * Function to render widget content to site
     */
    public function widget($widget_args, $instance)
    {
        extract($widget_args, EXTR_SKIP);

        $this->oc_api->prepare_widget_query($instance);
        $article_array = $this->oc_api->get_oc_articles();

        print $before_widget;

        $ocobjwid_article_template = null;
        if (isset($instance["article_template"]) && file_exists(EveryBoard_Settings::get_template_path($instance["article_template"]))) {
            $ocobjwid_article_template = EveryBoard_Settings::get_template_path($instance["article_template"]);
        }

        $widget_title = $instance['title'] ?? '';

        if (isset($widget_title) && $widget_title !== '') {
            //This will echo widget title, not article title
            print '<div class="widget_title_div">';
            print '<h3 class="widget_title">' . esc_attr($widget_title) . '</h3>';
            print '</div>';
        }

        $count = 1;
        foreach ($article_array as $key => $ocArticle) {

            // Set variables the template will expect
            $article = $ocArticle;

            /** @noinspection PhpUnusedLocalVariableInspection */
            $args = $widget_args['template_args'] ?? [];

            if ($ocobjwid_article_template !== null) {

                $article_img = isset($article_data['article_images']) ? $article_data['article_images'][0] : [];
                $article_title = $article->headline[0] ?? '';
                $artile_leadin = $article->leadin[0] ?? null;
                $article_author = $article->author[0] ?? null;
                $article_text = $article->text[0] ?? '';
                $article_counter = $count++;

                include $ocobjwid_article_template;
            } elseif (file_exists(EveryBoard_Settings::get_template_path("templates/ocarticle-default.php"))) {
                include EveryBoard_Settings::get_template_path("templates/ocarticle-default.php");
            } else {
                $board_renderer = new EveryBoard_Renderer();
                print $board_renderer->render_article_template_fallback($ocArticle);
            }
        }

        print $after_widget;
    }

    public function widget_board($instance)
    {
        $this->oc_api->prepare_widget_query($instance);
        $article_array = $this->oc_api->get_oc_articles();
        print "<br />";

        foreach ($article_array as $article) {
            if ($article instanceof \OcArticle) {
                $headline = $article->headline[0] ?? '';

                if (empty($headline)) {
                    $headline = 'No title';
                }

                echo '<p><strong>' . $headline . '</strong></p>';
            }
        }
    }

    /*
     * Function to declare admin UI for widget
     */
    public function form($instance)
    {
        $this->title_field($instance);
        $this->oc_query_field($instance);
        $this->article_template($instance);
    }

    /*
     * Function to fetch query for widget.
     */
    public function get_oc_query($instance)
    {
        if (isset($instance)) {
            $this->oc_api->prepare_widget_query($instance);

            return $this->oc_api->get_active_query();
        }
    }
}
